<template>
  <div>
    <Loader :visible="isLoading > 0" />
    <v-row class="foundation" v-if="company">
      <v-col offset-md="3" md="6" sm="12">
        <div
          class="
            text-h5 text-md-h4 text-center
            mb-8
            form-title
            tway-gray-dark--text
          "
        >
          Presentación de Proyecto
        </div>
        <div
          class="
            text-h5 text-md-h4 text-left
            mb-2
            form-title
            tway-gray-dark--text
          "
          style="font-size: 16.5pt !important"
        >
          Mi Perfil
          <tooltip-component :content="perfil" />
        </div>

        <!-- Presentación del Proyecto -->

        <v-card class="py-6 mb-10" elevation="4">
          <div class="px-6">
            <div class="input-label">Nombre Empresa</div>
            <div class="text-profile roboto">
              {{ company.name }}
            </div>
          </div>
          <v-divider class="mb-4 mt-3" />
          <div class="px-6">
            <div class="input-label">Negocio principal</div>
            <div class="text-profile roboto">
              {{
                company.industrialSector ? company.industrialSector.name : ""
              }}
            </div>
          </div>
          <v-divider class="mb-4 mt-3" />
          <div class="px-6">
            <div class="input-label">Acerca de la Empresa</div>
            <div class="text-profile roboto">
              {{ company.contributionValue }}
            </div>
          </div>
          <v-divider class="mb-4 mt-3" />
          <div class="px-6">
            <div class="input-label">Inicio de Actividades</div>
            <div class="text-profile roboto">
              {{ company.trajectory }}
            </div>
          </div>
          <v-divider class="mb-4 mt-3" />
          <div class="px-6">
            <div class="input-label">Sitio Web</div>
            <div class="text-profile roboto">
              {{ company.web }}
            </div>
          </div>
          <v-divider class="mb-4 mt-3" />
          <div class="px-6">
            <div class="input-label">Perfil LinkedIn</div>
            <div class="text-profile roboto">
              {{ company.linkedIn }}
            </div>
          </div>
        </v-card>

        <!-- Fundamentación del Proyecto -->

        <div
          class="
            text-h5 text-md-h4 text-left
            mb-2
            form-title
            tway-gray-dark--text
          "
          style="font-size: 18pt !important"
        >
          Desafío Estratégico
          <tooltip-component :content="desafio" />
        </div>
        <v-card class="py-6 mb-6" elevation="4">
          <div class="px-6">
            <div v-if="showIMTD">
              <div class="d-flex justify-space-around">
                <div class="text-center">
                  <div class="input-label mb-4" style="font-weight: 600">
                    IMTD
                    <tooltip-component />
                  </div>
                  <v-progress-circular
                    :indeterminate="!this.dtiData.dtiValue"
                    :rotate="360"
                    :size="100"
                    :width="14"
                    :value="55"
                    color="#16C62E"
                  >
                    {{ dtiData.dtiValue }}%
                  </v-progress-circular>
                </div>
                <div class="d-block mr-4">
                  <div class="d-flex mb-2 justify-space-around">
                    <div>
                      <div class="text-subtitle-1 mb-2">
                        Dimensión a impactar
                      </div>
                      <div class="tway-headline-3 mr-4">
                        {{
                          this.formData.dimension
                            ? this.formData.dimension.name
                            : ""
                        }}
                      </div>
                    </div>
                    <v-progress-circular
                      class="ml-6"
                      :indeterminate="!this.dtiData.dimensionValue"
                      :rotate="360"
                      :size="60"
                      :width="8"
                      :value="20"
                      color="#16C62E"
                    >
                      {{ this.dtiData.dimensionValue }}%
                    </v-progress-circular>
                  </div>
                  <v-divider class="mb-4 mt-4" />
                  <div class="d-flex mb-2 justify-space-around">
                    <div>
                      <div class="text-subtitle-1 mb-2">
                        Componente a impactar
                      </div>
                      <div class="tway-headline-3 mr-4">
                        {{
                          this.formData.subDimension
                            ? this.formData.subDimension.name
                            : ""
                        }}
                      </div>
                    </div>
                    <v-progress-circular
                      :indeterminate="!this.dtiData.subDimensionValue"
                      class="ml-6"
                      :rotate="360"
                      :size="60"
                      :width="8"
                      :value="30"
                      color="#16C62E"
                    >
                      {{ dtiData.subDimensionValue }}%
                    </v-progress-circular>
                  </div>
                </div>
              </div>
            </div>
            <v-form v-else v-model="valid">
              <div class="mb-4">Dimensión a impactar</div>
              <v-select
                return-object
                :rules="[requiredObject('Dimensión a impactar')]"
                :items="dimensions"
                @change="formData.subDimension = null"
                v-model="formData.dimension"
                outlined
                item-value="id"
                item-text="name"
                class="mb-4 roboto"
                color="deep-purple accent-4"
                placeholder="Selecciona una Dimensión de la lista"
              />
              <div
                :class="[
                  'input-label',
                  'mb-4',
                  { 'grey--text': !formData.dimension },
                  'lighten-5',
                ]"
              >
                Componente de Dimensión a impactar
              </div>
              <v-select
                return-object
                :rules="[requiredObject('Componente de Dimensión a impactar')]"
                :items="
                  formData.dimension ? formData.dimension.subdimensions : []
                "
                v-model="formData.subDimension"
                :disabled="!formData.dimension"
                outlined
                item-value="id"
                item-text="name"
                class="mb-4 roboto"
                color="deep-purple accent-4"
                placeholder="Selecciona un Componente de la Lista"
              />
              <div class="d-flex justify-center roboto">
                <v-btn
                  class="text-uppercase text-body-1 roboto"
                  rounded
                  text
                  x-small
                  color="deep-purple accent-4"
                  style="font-size: 11pt !important"
                  :disabled="!(formData.dimension && formData.subDimension)"
                  @click="changeMode"
                >
                  Mostrar resultados
                </v-btn>
              </div>
            </v-form>
          </div>
        </v-card>
        <div
          class="
            text-h5 text-md-h4 text-left
            mb-2
            form-title
            tway-gray-dark--text
          "
          style="font-size: 18pt !important"
        >
          Servicio según recomendaciones
          <tooltip-component :content="servicio" />
        </div>
        <v-card class="py-6 mb-6" elevation="4">
          <div class="px-6">
            <choice
              :data="formData.subDimension ? categoriesChoice : []"
              :data-selections="recomendationName"
              @array="recomendationName = $event"
              ref="choice"
              class="roboto"
            />
            <!--
            <v-select
              return-object
              :rules="[requiredObject('Componente de Dimensión a impactar')]"
              :items="formData.subDimension ? categoriesChoice : []"
              v-model="recomendationName"
              :disabled="!formData.subDimension"
              outlined
              item-text="name"
              class="mb-4 roboto"
              color="deep-purple accent-4"
              placeholder="Selecciona un servicio relacionado al proyecto"
            />
            -->
          </div>
        </v-card>
        <div class="d-flex justify-center">
          <v-btn
            large
            depressed
            rounded
            :disabled="!valid"
            @click="createProject"
            class="tway-violet white--text roboto elevation-3"
          >
            comenzar formulario DE DESCRIPCIÓN DE PROYECTO
          </v-btn>
        </div>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import Loader from "@/components/Loader";
import ValidatorsService from "@/services/validatorsService";
import companyService from "@/services/companyService";
import dtService from "@/services/dtService";
import currentUserService from "@/services/currentUserService";
import callForTenderService from "@/services/callForTenderService";
import { mapActions } from "vuex";
import Choice from "@/components/elements/Choice.vue";

// Framework
import Tooltip from "@/components/framework/Tooltip";

export default {
  name: "Foundation",
  components: {
    // Framework
    "tooltip-component": Tooltip,
    // ---
    Loader,
    choice: Choice,
  },
  data() {
    return {
      init: false,
      valid: false,
      company: null,
      isLoading: 0,
      dimensions: [],
      showIMTD: false,
      formData: {
        dimension: null,
        subDimension: null,
        category: null,
        initialScore: null,
        companyInfo: null,
      },
      dtiData: {
        surveyId: null,
        dtiValue: null,
        dimensionValue: null,
        subDimensionValue: null,
        dimensionId: "",
        subDimensionId: "",
      },
      recomendationName: "",
      categories: [],
      perfil:
        "Se muestran los datos de tu perfil para revisar si están correctamente actualizados",
      desafio: "El desafío estratégico es tu prioridad para mejorar tu IMTD.",
      servicio:
        "Servicios que se presentan en la sección Recomendaciones de tu Dashboard para mejorar tu IMTD",
      categoriesChoice: [],
    };
  },
  created() {
    this.loadCompanyData();
    this.loadUserInfo();
    this.getCategories();

    let queryParams = this.$route.query;
    if (queryParams.dimension && queryParams.subdimension) {
      this.showIMTD = true;
    }
  },
  methods: {
    ...mapActions({ setProject: "createProject/setProjectFromDB" }),
    required: (propertyType) => ValidatorsService.required(propertyType),
    requiredObject: (propertyType) =>
      ValidatorsService.requiredObject(propertyType),
    toFixed(num, fixed) {
      var re = new RegExp("^-?\\d+(?:\\.\\d{0," + (fixed || -1) + "})?");
      return num.toString().match(re)[0];
    },
    createProject() {
      this.isLoading++;
      this.showIMTD = true;
      // let categorieSelected = this.formData.subDimension.categories.filter(e => {
      //   return e.recomendationName == this.recomendationName;
      // });
      this.formData.services = this.recomendationName;
      this.loadDti().then(() => {
        callForTenderService
          .createProject(this.formData)
          .then((project) => {
            this.setProject(project).then(() =>
              this.$router.push(`create-project/${project.id}`)
            );
          })
          .catch((err) => this.$log.error(err))
          .finally(() => this.isLoading--);
      });
    },
    loadCompanyData() {
      this.isLoading++;
      companyService
        .getCompanyProfile()
        .then((company) => {
          this.company = company;
          this.formData.companyInfo = {
            name: company.name,
            mainIndustrialSector: company.industrialSector
              ? company.industrialSector.name
              : "",
            contributionValue: company.contributionValue,
            trajectory: company.trajectory,
          };
        })
        .catch((err) => this.$log.error(err))
        .finally(() => this.isLoading--);
    },
    getCategories() {
      dtService
        .getCategories()
        .then((categories) => {
          this.categories = categories;
        })
        .catch((err) => this.$log.error(err))
        .finally(() => this.isLoading--);
    },
    loadUserInfo() {
      this.isLoading++;
      return currentUserService
        .currentUserData()
        .then((userData) => {
          this.userData = userData;
          this.loadSurveyData();
        })
        .catch((err) => this.$log.error(err))
        .finally(() => this.isLoading--);
    },
    loadSurveyData() {
      this.isLoading++;
      dtService
        .getSurveyComplete("a123", this.userData.id)
        .then((questions) => {
          this.dtiData.surveyId = questions.surveyId;
          this.loadDimensionsData();
        })
        .catch((err) => this.$log.error(err))
        .finally(() => this.isLoading--);
    },
    loadDimensionsData() {
      this.isLoading++;
      dtService
        .getDti(this.userData.id, this.dtiData.surveyId)
        .then((dti) => {
          this.dimensions = dti.dimensions;
          // this.dimensions = this.dimensions.map((e,i) => {
          //   e.subdimensions = e.subdimensions.map((sub,j) => {
          //     sub.categories = null;
          //     dtService
          //       .getCategoriesBySub(sub.id)
          //       .then((categories) => {
          //         this.dimensions[i].subdimensions[j].categories = categories;
          //         console.log(this.dimensions[i].subdimensions[j].categories);
          //       })
          //       .catch((err) => this.$log.error(err));
          //     return sub;
          //   });
          //   return e;
          //   // llamada para las categorias con e.id
          // });
          this.processInitialData();
        })
        .catch((err) => this.$log.error(err))
        .finally(() => this.isLoading--);
    },
    processInitialData() {
      let queryParams = this.$route.query;
      if (queryParams.dimension && queryParams.subdimension) {
        this.formData.dimension = this.dimensions.find(
          (d) => d.id === queryParams.dimension
        );
        this.formData.subDimension = this.formData.dimension.subdimensions.find(
          (d) => d.id === queryParams.subdimension
        );
        this.loadDti();
        this.valid = true;
      }
    },
    loadDti() {
      this.isLoading++;
      return dtService
        .getDti(this.userData.id, this.dtiData.surveyId)
        .then((dti) => {
          let dimensionData = dti.dimensions.find(
            (d) => d.id === this.formData.dimension.id
          );
          let subDimensionData = dimensionData.subdimensions.find(
            (s) => s.id === this.formData.subDimension.id
          );

          this.dtiData.dtiValue = this.toFixed(dti.score * 10, 0);
          this.dtiData.dimensionValue = this.toFixed(
            (dimensionData.idx * 10) / dimensionData.value,
            0
          );
          this.dtiData.subDimensionValue = this.toFixed(
            (subDimensionData.idx * 10) / subDimensionData.value,
            0
          );
          this.dtiData.dimensionId = dimensionData.id;
          this.dtiData.subDimensionId = subDimensionData.id;

          this.formData.initialScore = dti.score;
        })
        .finally(() => this.isLoading--);
    },
    changeMode() {
      let formData = this.formData;
      if (formData.dimension && formData.subDimension) {
        this.showIMTD = !this.showIMTD;
        if (this.showIMTD) {
          this.loadDti();
        }
      }
    },
  },

  watch: {
    "formData.subDimension"() {
      this.categoriesChoice = [];
      if (this.formData.subDimension) {
        dtService
          .getCategoriesBySub(this.formData.subDimension.id)
          .then((categories) => {
            this.categoriesChoice = categories;
          })
          .catch((err) => this.$log.error(err));
      }
    },
  },

  //computed: {
  //CategoriesList() {
  //console.log(this.formData.subDimension.categories);
  //return this.formData.subDimension.categories || ["Sin Categoria"];
  // this.$refs.choice.clean();
  // console.log(this.formData.subDimension.categories);

  // // let test = [
  // //   {
  // //     id: "5f85d1609de0f921c6c46d33",
  // //     name: "Titulo categoria 1",
  // //     recomendationName: "Automatización y Optimización de Procesos",
  // //   },
  // //   {
  // //     id: "5f85d1549de0f921c6c46d32",
  // //     name: "Titulo categoria 2",
  // //     recomendationName: "Arquitectura Empresarial",
  // //   },
  // //   {
  // //     id: "5f85d1359de0f921c6c46d31",
  // //     name: "Analytics",
  // //     recomendationName: "Herramientas de Análisis",
  // //   }
  // // ]
  // let data = [];
  // this.formData.subDimension.categories.forEach(e => {
  // //test.forEach(e => {
  //   data.push({
  //     name: e.name,
  //     id: e.id,
  //     recomendations: [
  //       {
  //         name: e.recomendationName,
  //         id: e.id
  //       }
  //     ]
  //   })
  // });
  // console.log(data);
  // return data;
  //},
  //},
};
</script>

<style scoped>
.form-title {
  font-size: 18.75pt !important;
}
.text-profile {
  font-family: Roboto;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 19px;
  color: #757575;
}
</style>

<style>
.v-application .foundation .v-list-item__title {
  font-family: "Roboto" !important;
}
.foundation .v-progress-circular__info {
  color: #4b168c !important;
}
</style>
